//------------------------------------------------------
//  :  DRAW.CPP
//  :   DirectDraw
//------------------------------------------------------
#define WIN32_LEAN_AND_MEAN

#include "glass.h"
#include <MATH.H>

#include <windows.h>
#include <ddraw.h>
#include <mmsystem.h>


#include "draw.h"
#include "main.h"
#include "mylib\rectable.h"

#include <stdlib.h>

#include "tetris.h"

//CGLASS * glass;
TETRIS Tetris;

int MAX_WIDTH=1024;
int MAX_HEIGHT=768;

//  
#define FRAMES_COUNT	1

void UpdateGameOver();

int CUBIC_WIDTH=38;
#define CUBIC_COUNT 8

static int nFps=0;

static HWND hMainWnd;

COLORREF CubicColors[8]={
		RGB(255,0,0),
		RGB(0,255,0),
		RGB(0,0,255),
		RGB(255,0,255),
		RGB(255,255,0),
		RGB(0,255,255),
		RGB(255,255,255),
		RGB(255,255,255)
	};


LPDIRECTDRAW7 pDD;
LPDIRECTDRAWSURFACE7 pPrimarySurface;
LPDIRECTDRAWSURFACE7 pPicFrames[FRAMES_COUNT];
LPDIRECTDRAWSURFACE7 pBackGroundSurface;
LPDIRECTDRAWSURFACE7 pFPS;
LPDIRECTDRAWSURFACE7 pBackBuffer;
LPDIRECTDRAWSURFACE7 pGameOverSurface;

int DrawCubic(int x1, int y1, int ONE_LEN,COLORREF bx,HDC mDC);

void Effect()
{


	DDSURFACEDESC2 ddSurfaceDesc;
	HRESULT hRet;

	ZeroMemory(&ddSurfaceDesc,sizeof(ddSurfaceDesc));
	ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);

	//    
	pBackBuffer->BltFast(0,0, 
	pPrimarySurface, NULL, DDBLTFAST_WAIT);

	hRet=pBackBuffer->Lock(NULL,&ddSurfaceDesc,
			DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,NULL);
	
	if(FAILED(hRet))
	{
		return;
	}

	UINT surfaceWidth=ddSurfaceDesc.lPitch;
	UINT surfaceHeight=ddSurfaceDesc.dwHeight;
	UINT surfaceElementCount=surfaceWidth*surfaceHeight;

	BYTE * videoMemory=(BYTE*)ddSurfaceDesc.lpSurface;
	
	DWORD color=0;
	
	_asm {
		mov eax,color
		mov ecx,surfaceElementCount
		mov edi,videoMemory
lop:
		mov eax,[edi]
		add eax,123124
		mov [edi],eax
		add edi,4
		dec ecx
		jnz lop
		
		}
	
	pBackBuffer->Unlock(NULL);

	pPrimarySurface->Flip(NULL, DDFLIP_NOVSYNC| DDFLIP_DONOTWAIT );
	
}



char* pFileNames[FRAMES_COUNT] = {"dx000.bmp"};
//   
static int frame = 0;

double x=100,y=100,speedx=0,speedy=0;

int rand(int n)
{
	return rand()%n;
}

#define MAX_OBJECTS 20
//----------------------------------------------------
struct MOVEOBJ
{
	double x,y,speedx,speedy;
	int type;

	MOVEOBJ()
	{
		type=rand(7);
		x=rand(MAX_WIDTH-CUBIC_WIDTH);
		y=rand(MAX_HEIGHT-CUBIC_WIDTH);
		speedx=0.01*rand(10);

		if (rand(2)) speedx*=-1;

		speedy=0.01*rand(10);

		if (rand(2)) speedy*=-1;

	}
	void Move() {
		x+=speedx; y+=speedy;
		x+=speedx;

	if (x<0) speedx*=-1;

	y+=speedy;

	if (y<0) speedy*=-1;

	if (x>MAX_WIDTH-CUBIC_WIDTH) speedx*=-1,Move();
	if (y>MAX_HEIGHT-CUBIC_WIDTH) speedy*=-1,Move();


	}
	
} Object[MAX_OBJECTS];
//----------------------------------------------------
struct  {
	int left,right,down,up;
} Key={0,0,0,0};

//---------------------------------------------------------
//  
void DX_OnKeyUp(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
	/*if (vk==VK_LEFT) Key.left=0;
	if (vk==VK_RIGHT) Key.right=0;
	if (vk==VK_DOWN) Key.down=0;
	if (vk==VK_UP) Key.up=0;*/

	if (vk==VK_LEFT) Tetris.NeedMoveLeft=false;

	if (vk==VK_RIGHT) Tetris.NeedMoveRight=false;
	
	if (vk==VK_DOWN)Tetris.NeedMoveDown=0;

	if (vk=='S') Tetris.glass->Score+=100;

}

//---------------------------------------------------------
//   
void DX_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
	//     
//		DestroyWindow(hwnd);

	Tetris.OnKeyDown(vk);

/*	if (vk=='Z')
	{
		for(int x=0; x<Tetris.glass->Len; x++)
		for(int y=0; y<Tetris.glass->Hei; y++)
		{
			BOX bx;
			bx.color=RGB(255,255,255);
			bx.type=4;//rand(7);
 			Tetris.glass->Read(x,y,bx);

		}
	}
*/

	if (vk==VK_RETURN)
	{
		for(int i=0; i<CUBICANIMATION::Count; i++)
		{
			double a=Tetris.CubicAnimation[i].Accelerat.y;
			a=-fabs(a);
			Tetris.CubicAnimation[i].Accelerat.y=a;
			
		}
	}

	if (vk=='E') 
	{
		Effect();
	}

	/*if (vk=='Z')
	{
		Tetris.glass->Score+=100;
	}

	if (vk=='S')
	{
		Tetris.GameMode=TETRIS::MODE_INPUTNAME;
		Tetris.InputString="";
	}

	if (vk=='F')
	{
		Tetris.CreateAnimation2();
	}*/
/*
	if (vk==VK_LEFT) Key.left++;
	if (vk==VK_RIGHT) Key.right++;
	if (vk==VK_DOWN) Key.down++;
	if (vk==VK_UP) Key.up++;
*/

	if (vk==VK_LEFT)
	{
		Tetris.NeedMoveLeft=true;
		Tetris.NeedMoveLeftRightCounter=255;
	}

	if (vk==VK_RIGHT)
	{
		Tetris.NeedMoveRight=true;
		Tetris.NeedMoveLeftRightCounter=255;
	}


	if (vk==VK_DOWN && Tetris.NeedMoveDown==0)
	{
		Tetris.NeedMoveDown=1;
	}

	if (vk==VK_UP)
	{
		Tetris.Rotate();
	}


}

//---------------------------------------------------------
//,    
//
void ErrorHandle(HWND hwnd, LPCTSTR szError)
{
	//,       
	char szErrorMessage[255];
	//    ,
	//   DirectDraw
	RemoveDirectDraw();
	//  
	ShowWindow(hwnd, SW_HIDE);
	//   
	wsprintf(szErrorMessage, " \n  %s", szError);
	MessageBox(hwnd, szErrorMessage, AppName, MB_OK);
	// 
	DestroyWindow(hwnd);
}
//---------------------------------------------------------
//  ,   DirectDraw
//
void RemoveDirectDraw()
{
	//,    IDirectDraw7
	if (pDD != NULL)
	{
		//,     
		if (pPrimarySurface!=NULL)
		{
			//   
			pPrimarySurface->Release();
			pPrimarySurface = NULL;
		}
		//    
		for (int i = 0; i<FRAMES_COUNT;i++)
		{
			if (pPicFrames[i]!=NULL)
			{
				//  
				pPicFrames[i]->Release();
				pPicFrames[i]=NULL;
			}
		}

		//  DirectDraw
		pDD->Release();
		pDD=NULL;
	}
}
//---------------------------------------------------------
// DirectDraw
//
BOOL InitDirectDraw (HWND hwnd)
{
	//   
	HRESULT hRet;

	//  
	pPrimarySurface=NULL;
	pBackBuffer=NULL;

	for (int i=0; i<FRAMES_COUNT; i++)
		pPicFrames[i]=NULL;

	hMainWnd=hwnd;

	//  IDirectDraw7
	hRet=DirectDrawCreateEx(NULL, (VOID**)&pDD, IID_IDirectDraw7, NULL);
	if (hRet!=DD_OK)
	{
		ErrorHandle(hMainWnd, "DirectDrawCreate");
		return (FALSE);
	}

	//   
	hRet=pDD->SetCooperativeLevel(hMainWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
	//hRet=pDD->SetCooperativeLevel(NULL, DDSCL_NORMAL);
	if (hRet!=DD_OK)
	{
		ErrorHandle(hMainWnd,"SetCooperativeLevel");
		return (FALSE);
	}

	MAX_WIDTH=GetSystemMetrics(SM_CXSCREEN);
	MAX_HEIGHT=GetSystemMetrics(SM_CYSCREEN);


	/*//    > 1024x768  1024  768
	if (MAX_WIDTH>1024 && MAX_HEIGHT>768)
	{
	
		MAX_WIDTH=1024;
		MAX_HEIGHT=768;
		//  
		hRet=pDD->SetDisplayMode(MAX_WIDTH, MAX_HEIGHT, 32, 85, NULL);
		if (hRet!=DD_OK)
		{
			ErrorHandle(hMainWnd,"SetDisplayMode");
			return (FALSE);
		}
	}
	*/
	
	CUBIC_WIDTH=MAX_HEIGHT/21;

	//   
	if (!CreateSurfaces())
	{
		ErrorHandle(hMainWnd, "CreateSurfaces");
		return (FALSE);
	}

	//     
	if (!PrepareSurfaces())
	{
		ErrorHandle(hMainWnd, "ConfigureSurfaces");
		return (FALSE);
	}

	return (TRUE);
}

void SetColorsKeys()
{
		//    " "
	DDCOLORKEY ddColorKey;
	ddColorKey.dwColorSpaceLowValue=TRASPARENT_COLOR;
	ddColorKey.dwColorSpaceHighValue=TRASPARENT_COLOR;

	// " "    
	for (int i=0; i<FRAMES_COUNT; i++)
		pPicFrames[i]->SetColorKey(DDCKEY_SRCBLT, &ddColorKey);

	pFPS->SetColorKey(DDCKEY_SRCBLT, &ddColorKey);
	pBackGroundSurface->SetColorKey(DDCKEY_SRCBLT, &ddColorKey);
	pGameOverSurface->SetColorKey(DDCKEY_SRCBLT, &ddColorKey);

}

//---------------------------------------------------------
// 
//
BOOL CreateSurfaces()
{


	//     DirectDraw
	//  
	DDSURFACEDESC2 ddSurfaceDesc;
	DDSCAPS2 ddsCaps;
	HRESULT hRet;

	//   ""     
	ZeroMemory(&ddSurfaceDesc, sizeof(ddSurfaceDesc));
	ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);

	//   
	ddSurfaceDesc.dwFlags=DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddSurfaceDesc.ddsCaps.dwCaps=DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	//ddSurfaceDesc.ddsCaps.dwCaps=DDSCAPS_PRIMARYSURFACE | DDSCAPS_COMPLEX;
	ddSurfaceDesc.dwBackBufferCount=1;

	// 
	hRet=pDD->CreateSurface(&ddSurfaceDesc,	&pPrimarySurface, NULL);
	if (hRet!=DD_OK)
	{
		char mes[256];
		wsprintf(mes,"%lx",hRet);
		MessageBox(NULL,mes,NULL,MB_OK);
		return (FALSE);
	}

	//  
	ZeroMemory(&ddsCaps, sizeof(ddsCaps));
	ddsCaps.dwCaps=DDSCAPS_BACKBUFFER;
	hRet=pPrimarySurface->GetAttachedSurface(&ddsCaps, &pBackBuffer);
	if(hRet!=DD_OK)
		return (FALSE);

	//  
	for (int i=0; i<FRAMES_COUNT; i++)
	{
		ZeroMemory(&ddSurfaceDesc, sizeof(ddSurfaceDesc));
		ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);
		ddSurfaceDesc.dwFlags=DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
		ddSurfaceDesc.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN;
		ddSurfaceDesc.dwHeight=FRAME_HEIGHT;
		ddSurfaceDesc.dwWidth=FRAME_WIDTH;
		hRet=pDD->CreateSurface(&ddSurfaceDesc, &pPicFrames[i], NULL);
		if(hRet!=DD_OK)
			return (FALSE);
	}

	//   
	ZeroMemory(&ddSurfaceDesc, sizeof(ddSurfaceDesc));
	ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);
	ddSurfaceDesc.dwFlags=DDSD_CAPS |
	DDSD_HEIGHT | DDSD_WIDTH;
	ddSurfaceDesc.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN;
	ddSurfaceDesc.dwWidth=CUBIC_WIDTH*CUBIC_COUNT;
	ddSurfaceDesc.dwHeight=CUBIC_WIDTH*CUBIC_WIDTH;
	hRet=pDD->CreateSurface(&ddSurfaceDesc, &pBackGroundSurface, NULL);
	if(hRet!=DD_OK) return (FALSE);
	//-------------------------------------------------------

	//    FPS
	ZeroMemory(&ddSurfaceDesc, sizeof(ddSurfaceDesc));
	ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);
	ddSurfaceDesc.dwFlags=DDSD_CAPS |
	DDSD_HEIGHT | DDSD_WIDTH;
	ddSurfaceDesc.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN;
	ddSurfaceDesc.dwHeight=FPS_HEIGHT;
	ddSurfaceDesc.dwWidth=FPS_WIDTH;
	hRet=pDD->CreateSurface(&ddSurfaceDesc, &pFPS, NULL);
	if(hRet!=DD_OK) return (FALSE);
	//-------------------------------------------------------

	//     GAME OVER
	ZeroMemory(&ddSurfaceDesc, sizeof(ddSurfaceDesc));
	ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);
	ddSurfaceDesc.dwFlags=DDSD_CAPS |
	DDSD_HEIGHT | DDSD_WIDTH;
	ddSurfaceDesc.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN;
	ddSurfaceDesc.dwHeight=GAMEOVER_HEIGHT;
	ddSurfaceDesc.dwWidth=GAMEOVER_WIDTH;
	hRet=pDD->CreateSurface(&ddSurfaceDesc, &pGameOverSurface, NULL);
	if(hRet!=DD_OK) return (FALSE);
	//-------------------------------------------------------

	SetColorsKeys();



	return (TRUE);
}
//---------------------------------------------------------
//   
BOOL PrepareSurfaces()
{
	//       
	for (int i=0; i<FRAMES_COUNT; i++)
	{
		if (!LoadBMP(pPicFrames[i], pFileNames[i]))
			return (FALSE);
	}
	
	ClearSurface(pFPS);
	ClearSurface(pGameOverSurface);


	HDC hdc;

	if (pBackGroundSurface->GetDC(&hdc) == DD_OK)
	{
		for(int y=0; y<CUBIC_WIDTH; y++)
		//    
		for(int i=0; i<CUBIC_COUNT; i++)
		{
			DrawCubic(i*CUBIC_WIDTH,y*CUBIC_WIDTH,CUBIC_WIDTH-y,CubicColors[i],hdc);
		}

		pBackGroundSurface->ReleaseDC(hdc);
	}

	// 
	Tetris.glass=new CGLASS(10,20, pBackGroundSurface);
	Tetris.fig.glass=Tetris.glass;
	Tetris.Rectable.glass=Tetris.glass;
	//CUBICANIMATION::Count=20;
	//Tetris.CreateAnimation();

	return (TRUE);
}
//---------------------------------------------------------
//   BMP-
//
BOOL LoadBMP(LPDIRECTDRAWSURFACE7 pSurface, char* filename)
{
	// ,      BMP-
	BYTE* pBmp;
	DWORD dwBmpSize;
	DWORD dwFileLength;
	DWORD nBytesRead;

	BITMAPINFO* pBmpInfo;
	BYTE*		pPixels;

	HDC hdc;

	//    
	HANDLE hFile=CreateFile(filename, GENERIC_READ,
			FILE_SHARE_READ, NULL,OPEN_EXISTING, 0, NULL);
	if (hFile==INVALID_HANDLE_VALUE)
		return (FALSE);

	//     
	dwFileLength=GetFileSize (hFile, NULL) ;
	dwBmpSize=dwFileLength-sizeof(BITMAPFILEHEADER);

	//   
	pBmp=	(BYTE*) malloc(dwBmpSize);
	SetFilePointer(hFile, sizeof(BITMAPFILEHEADER), NULL, FILE_BEGIN);

	//   
	ReadFile(hFile, (LPVOID)pBmp, dwBmpSize, &nBytesRead, NULL);
	CloseHandle(hFile);

	pBmpInfo=(BITMAPINFO*)pBmp;
	pPixels=pBmp+sizeof(BITMAPINFOHEADER);//+sizeof(RGBQUAD)*256;

	//     
	if ((pSurface->GetDC(&hdc)) == DD_OK)
	{
	//    
	//    GDI
		StretchDIBits(hdc , 0, 0, FRAME_WIDTH, FRAME_HEIGHT, 0, 0, FRAME_WIDTH, FRAME_HEIGHT, pPixels, pBmpInfo, 0, SRCCOPY);
		pSurface->ReleaseDC(hdc);
	}
	// 
	free(pBmp);

	return (TRUE);
}

//---------------------------------------------------------
//   ""
//
void PrepareFrame()
{
	//  ""  
	if (pPrimarySurface->IsLost())
	{
		//     
		pPrimarySurface->Restore();
		pBackBuffer->Restore();

		//    ""
		for (int i=0; i<FRAMES_COUNT; i++)
		{
			if (pPicFrames[i]->IsLost())
			{
				//  
				//     
				pPicFrames[i]->Restore();
				LoadBMP(pPicFrames[i], pFileNames[i]);
			}
		}

		if (pFPS->IsLost())
		{
			pFPS->Restore();
			ClearSurface(pFPS);
		}

		//    
		if (pBackGroundSurface->IsLost())
		{
			pBackGroundSurface->Restore();
		}

		PrepareSurfaces();

		SetColorsKeys();
	}
}

//---------------------------------------------------------
// 
//
BOOL FillSurface(LPDIRECTDRAWSURFACE7 pSurface)
{
	DDSURFACEDESC2 ddSurfaceDesc;
	HRESULT hRet;

	ZeroMemory(&ddSurfaceDesc,sizeof(ddSurfaceDesc));
	ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);

	hRet=pSurface->Lock(NULL,&ddSurfaceDesc,
			DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,NULL);
	
	if(FAILED(hRet))
	{
		return (FALSE);
	}

	UINT surfaceWidth=ddSurfaceDesc.lPitch;
	UINT surfaceHeight=ddSurfaceDesc.dwHeight;
	UINT surfaceElementCount=surfaceWidth*surfaceHeight;

	BYTE * videoMemory=(BYTE*)ddSurfaceDesc.lpSurface;
	
	DWORD color=0;
	
	for(UINT i=0; i<surfaceHeight; i++)
	{
		_asm{
		mov eax,color
		mov ecx,1024*4
		mov edi,videoMemory
		cld
		rep stosd
		}
		videoMemory+=surfaceWidth;
		color++;
	}
	
	pSurface->Unlock(NULL);
	return (TRUE);
}

//---------------------------------------------------------
void nul(int &a)
{
	//if (a<0) { a=-a; if (a<60) a=0;}
	if (a>255) a=255;
	if (a<40) a=0;
}


//---------------------------------------------------------
void FillSolidRect(HDC hdc, int x1,int y1,int x2,int y2,COLORREF clr)
{
	RECT rt={x1,y1, x2+x1,y2+y1};
	HBRUSH hbr=CreateSolidBrush(clr);

	FillRect(hdc,&rt,hbr);

	DeleteObject(hbr);

}

//---------------------------------------------------------
int DrawCubic(int x1, int y1, int ONE_LEN,COLORREF bx,HDC mDC)
{
	int ONE=ONE_LEN;

	if (ONE==0) return 0;

	if (!bx)
	{
		return 0;
	}

	int R=GetRValue(bx),
		B=GetBValue(bx), 
		G=GetGValue(bx);

	int r1,b1,g1;

	r1=R == 0 ? 0 : 1;
	b1=B == 0 ? 0 : 1;
	g1=G == 0 ? 0 : 1;


	int type=0;
	if (type==0)
	{
		for(int i=0; i<=ONE/2; i++)
		{
			//double Bright=225.0;
			double Bright=200.0;
			double	a=Bright/ONE*2,
					b=Bright/ONE*2;

			int k=ONE/2-i;

			int R1=int(R-r1*k*a),
				G1=int(G-g1*k*a),
				B1=int(B-b1*k*a);


			nul(R1); nul(G1); nul(B1);
			
		
			#define mac RGB(R1,G1,B1)
			FillSolidRect(mDC,x1+i,y1+i, ONE-i*2,1, mac);
			FillSolidRect(mDC,x1+i,y1+ONE-1-i, ONE-i*2,1, mac);

			FillSolidRect(mDC, x1+i,y1+i, 1, ONE-i*2, mac);
			FillSolidRect(mDC, x1+ONE-1-i,y1+i, 1,ONE-i*2, mac);
			#undef mac

		}
	}
	if (type==1)
	{
		FillSolidRect(mDC,x1,y1, ONE,ONE, 0);			
		for(double r=1; r<=ONE/2; r++)
		{
			int K=230;
			double	a=K/ONE*2,
					b=K/ONE*2;

			int k=int(ONE/2-r);

			int R1=int(R-r1*k*a),
				G1=int(G-g1*k*a),
				B1=int(B-b1*k*a);


			nul(R1); nul(G1); nul(B1);



			#define mac RGB(R1,G1,B1)

			HPEN hpen=CreatePen(PS_SOLID,1,mac);
			HBRUSH hbrush=CreateSolidBrush(mac);

			HPEN holdpen=(HPEN)SelectObject(mDC,hpen);
			HBRUSH holdbrush=(HBRUSH)SelectObject(mDC,hbrush);
			//FillSolidRect(mDC,x1+i,y1+i, ONE-i*2,1, mac);
			//FillSolidRect(mDC,x1+i,y1+ONE-1-i, ONE-i*2,1, mac);

			//FillSolidRect(mDC, x1+i,y1+i, 1, ONE-i*2, mac);
			//FillSolidRect(mDC, x1+ONE-1-i,y1+i, 1,ONE-i*2, mac);

			Ellipse(mDC,int(x1+r),int(y1+r),int(x1+ONE-r),int(y1+ONE-r));

			SelectObject(mDC,holdpen);
			SelectObject(mDC,holdbrush);

			DeleteObject(hpen);
			DeleteObject(holdbrush);

			#undef mac

		}
	}

/*	else if (type == 1)
	{

		#define mac RGB(R-r1*i*a,G-g1*i*a,B-b1*i*a)
		#define mac2 RGB(-R+r1*i*b,-G+g1*i*b,-B+b1*i*b)

		CBrush br;
		br.CreateStockObject(NULL_BRUSH);
		mDC.SelectObject(br);
			//GetStockObject

		for(int i=0; i<=ONE/2; i++)
		{
			//int b=255/ONE*2;
			int a=255/ONE;
			int b=255/ONE*2;
		//CBrush *oldbr=memDC.SelectObject(&br);
			CPen pen(PS_SOLID, 1, mac);
	#define s 5
			R-=s; G-=s; B-=s;
			if (R <0) R=0;
			if (G <0) G=0;
			if (B <0) B=0;
 				
				//RGB(-R+r1*i*b,-G+g1*i*b,-B+b1*i*b) 
				
				//);
			CPen * oldpen=mDC.SelectObject(&pen);
		mDC.Ellipse(x1+i,y1+i,x1+ONE-i,y1+ONE-i);
			mDC.SelectObject(oldpen);
		}
	}
	else if (type==2)
	{
		
		for(int i=0; i<ONE; i++)
		{
			int a=255/ONE;
			int b=255/ONE*2;
			mDC.FillSolidRect(x1,y1+i, ONE,1, mac);
		}
	}

	else //if (type==3)
	{
		mDC.FillSolidRect(x1,y1, ONE,ONE, bx.color);
	}
	/*else 
	{
		memDC.MoveTo(x1,y1);
		memDC.LineTo(x1+ONE,y1);
		memDC.LineTo(x1,y1+ONE);
	}*/


	return 0;
}


//---------------------------------------------------------
// 
//
BOOL ClearSurface(LPDIRECTDRAWSURFACE7 pSurface)
{
	DDSURFACEDESC2 ddSurfaceDesc;
	HRESULT hRet;

	ZeroMemory(&ddSurfaceDesc,sizeof(ddSurfaceDesc));
	ddSurfaceDesc.dwSize=sizeof(ddSurfaceDesc);

	hRet=pSurface->Lock(NULL,&ddSurfaceDesc,
			DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,NULL);
	if(FAILED(hRet))
	{
		return (FALSE);
	}

	UINT surfaceWidth=ddSurfaceDesc.lPitch;
	UINT surfaceHeight=ddSurfaceDesc.dwHeight;

	char *buf=(char*)ddSurfaceDesc.lpSurface;
	ZeroMemory(buf,surfaceWidth*surfaceHeight);

	pSurface->Unlock(NULL);
	return (TRUE);
}

int MouseX=0, MouseY=0;

void DX_OnMouseMove(WPARAM wParam,LPARAM lParam)
{
	/*MouseX=LOWORD(lParam);
	MouseY=HIWORD(lParam);
	*/
}


static bool buf6[]={
		1,1,0,
		0,1,1,
		0,0,0
};

CFIGURE figure(3,3, buf6);

void DrawCopyRight();

//---------------------------------------------------------
//   
//
void DrawFrame()
{
	// 
	PrepareFrame();

	RECT rPic;
	SetRect(&rPic, 0, 0, FRAME_WIDTH, FRAME_HEIGHT);

	//     
	//  

	static double angle;

	// 
	RECT dest={0,0,MAX_WIDTH,MAX_HEIGHT};
	DDBLTFX set={0};
	set.dwSize=sizeof(set);
	set.dwRotationAngle=int(angle);
	set.dwROP=SRCCOPY;

	pBackBuffer->Blt(&dest, 
	//pPicFrames[frame], &rPic,DDBLT_ROTATIONANGLE|DDBLT_ROP,&set);
	pPicFrames[0], &rPic,DDBLT_ROP,&set);
	//-------------------------------------------------------

	DrawCopyRight();

	Tetris.DrawPicture(pBackBuffer);

	static k=0;
	if (k==0) Tetris.fig=figure,k++;

	UpdateFPS();
	SetRect(&rPic, 0, 0, FPS_WIDTH, FPS_HEIGHT);
	pBackBuffer->BltFast((MAX_WIDTH-FPS_WIDTH)/2, 20, pFPS, &rPic, DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);

	
	// 
	pPrimarySurface->Flip(NULL, DDFLIP_NOVSYNC| DDFLIP_DONOTWAIT );
	//pPrimarySurface->Flip(NULL, DDFLIP_WAIT );
}

//---------------------------------------------------------
//   
//
void NextTick()
{
	/*frame++;
	if (frame==FRAMES_COUNT)
		frame=0;
	*/
	
}
//---------------------------------------------------------
//  
//

void DrawCopyRight()
{
	HDC hdc;
	if ((pBackBuffer->GetDC(&hdc)) == DD_OK)
		{

		static int count;



		int size=8;
		LOGFONT lf={0};
		lf.lfWidth=size;
		lf.lfHeight=2*size;
		lf.lfPitchAndFamily=FF_MODERN;

		HFONT hfont=CreateFontIndirect(&lf);

		HFONT oldfont=(HFONT)SelectObject(hdc,hfont);
		int z;		
		if (count<100) z=0;
		else z=255;

		z=155;
		
		SetTextColor(hdc,RGB(z,z,z));
		SetBkMode(hdc,TRANSPARENT);
		char *s="(C) 2004 E. Lapshin";
		char *s2="Specail to Lenusik&Pashok";
		
		TextOut(hdc, MAX_WIDTH-size*(strlen(s)+1),MAX_HEIGHT-2*size,s,strlen(s));
		TextOut(hdc, 0,0, s2,strlen(s));
		SelectObject(hdc,oldfont);
		DeleteObject(hfont);


		pBackBuffer->ReleaseDC(hdc);

		}
	}


void UpdateGameOver()
{
	HDC hdc;
	if ( pGameOverSurface->GetDC(&hdc) == DD_OK)
	{

		LOGFONT lf={0};
		lf.lfWidth=GAMEOVER_WIDTH/10;
		lf.lfHeight=GAMEOVER_HEIGHT;
		lf.lfPitchAndFamily=FF_MODERN|FIXED_PITCH;

		HFONT hfont=CreateFontIndirect(&lf);

		HFONT oldfont=(HFONT)SelectObject(hdc,hfont);

		SetTextColor(hdc,RGB(155,155,155));
		SetBkMode(hdc,TRANSPARENT);
		TextOut(hdc, 0,0,"Game Over",9);
	
		SelectObject(hdc,oldfont);
		DeleteObject(hfont);


		pGameOverSurface->ReleaseDC(hdc);

	}
	

}
	



void UpdateFPS()
{

	HDC hdc;
	char s[10];

	static const long lPeriod=20;
	static long lFrameNumber=0;
	static DWORD dwPrevTime;
	static DWORD dwCurTime;

	lFrameNumber+=1;
	if (lFrameNumber==lPeriod)
	{
		dwPrevTime=dwCurTime;
		dwCurTime=timeGetTime();

		double fSeconds=double(dwCurTime-dwPrevTime)/1000.0;
		nFps=(int)((double)lFrameNumber/fSeconds);

		lFrameNumber=0;

		wsprintf(s,"%d FPS",nFps);

		ClearSurface(pFPS);
		if ((pFPS->GetDC(&hdc)) == DD_OK)
		{
			SetTextColor(hdc,RGB(155,155,155));
			SetBkMode(hdc,TRANSPARENT);
			TextOut(hdc, 0,0,s,strlen(s));
			pFPS->ReleaseDC(hdc);
		}
	}
}


